"use strict";

var app = angular.module('ng-laravel', ['ui.select']);
app.controller('NewsletterCtrl', function($scope, ContactService, $http, $rootScope, $translatePartialLoader, Notification, trans, $state, $timeout){
			
    $scope.newsletterObj = {};

    $scope.sendRequest = function(newsletterObj) {
        $scope.isDisabled = true;
		$scope.tmp = angular.isObject(newsletterObj) ? angular.toJson(newsletterObj) : newsletterObj;
        ContactService.sendNewsletterRequest($scope.tmp);
    };  

    /********************************************************
     * Event Listeners
     * Task event listener related to NewsletterCtrl
     ********************************************************/
    // Send contact request event listener
    $scope.$on('newsletter.sendrequest', function() {
		Notification({message: 'Email has been added successfully.' ,templateUrl:'app/vendors/angular-ui-notification/tpl/success.tpl.html'},'success');
		$scope.newsletterObj = {};
		$scope.isDisabled = false;
    });

    //Validation error in send contact request event listener
    $scope.$on('newsletter.validationError', function(event,errorData) {
        Notification({message: errorData ,templateUrl:'app/vendors/angular-ui-notification/tpl/validation.tpl.html'},'warning');
        $scope.isDisabled = false;
    });

});